---
title: Update a RUM operation
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > RUM Operations
---

> For the complete documentation index, see [llms.txt](https://docs.datadoghq.com/llms.txt).

# Update a RUM operation{% #update-a-rum-operation %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview and is subject to change. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                               |
| ----------------- | -------------------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/rum/operations/{rum_operation_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/rum/operations/{rum_operation_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/rum/operations/{rum_operation_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/rum/operations/{rum_operation_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/rum/operations/{rum_operation_id}  |
| uk1.datadoghq.com | PUT https://api.uk1.datadoghq.com/api/v2/rum/operations/{rum_operation_id} |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/rum/operations/{rum_operation_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/rum/operations/{rum_operation_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/rum/operations/{rum_operation_id} |

### Overview

Update an existing RUM operation. Fields omitted from the request body keep their existing value, with the exception of `journey_rum`, which is required and fully replaced on every update.

### Arguments

#### Path Parameters

| Name                               | Type   | Description                                           |
| ---------------------------------- | ------ | ----------------------------------------------------- |
| rum_operation_id [*required*] | string | The unique identifier of the RUM operation to update. |

### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field | Field                         | Type     | Description                                                                                                                                                                                                                 |
| ------------ | ----------------------------- | -------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object   | The data object for updating a RUM operation.                                                                                                                                                                               |
| data         | attributes [*required*]  | object   | Attributes for creating or updating a RUM operation.                                                                                                                                                                        |
| attributes   | application_id                | uuid     | The RUM application ID the operation belongs to.                                                                                                                                                                            |
| attributes   | category                      | string   | The category of the RUM operation.                                                                                                                                                                                          |
| attributes   | description                   | string   | A description of the RUM operation.                                                                                                                                                                                         |
| attributes   | display_name                  | string   | A human-readable display name for the RUM operation.                                                                                                                                                                        |
| attributes   | feature_ids                   | [string] | The list of feature IDs associated with the RUM operation.                                                                                                                                                                  |
| attributes   | journey_rum [*required*] | object   | The definition of a RUM operation's journey, used to detect it from RUM events.                                                                                                                                             |
| journey_rum  | rum_steps [*required*]   | [object] | The ordered list of steps composing the RUM journey.                                                                                                                                                                        |
| rum_steps    | composite                     | object   | A composite rule combining several predicates. Used as an alternative to `nodes` on a journey step when several conditions must be matched together, in any order or in a specific order.                                   |
| composite    | composite_rule_id             | string   | The unique identifier of the composite rule. Generated by the server if omitted.                                                                                                                                            |
| composite    | config_version                | string   | A hash of the composite rule's configuration, computed by the server.                                                                                                                                                       |
| composite    | kind [*required*]        | enum     | The rule used to combine the composite rule's predicates. `all_of` requires every predicate to match, in any order. `in_order` requires every predicate to match in the given order. Allowed enum values: `all_of,in_order` |
| composite    | max_window_ms                 | int64    | The maximum time window, in milliseconds, in which all predicates must match.                                                                                                                                               |
| composite    | predicates [*required*]  | [object] | The list of predicates that must be matched by RUM events.                                                                                                                                                                  |
| predicates   | query [*required*]       | string   | The RUM search query used to match events for this predicate.                                                                                                                                                               |
| rum_steps    | nodes                         | [object] | The list of nodes that can match this step. Mutually exclusive with `composite`.                                                                                                                                            |
| nodes        | id                            | string   | The unique identifier of the node. Generated by the server if omitted.                                                                                                                                                      |
| nodes        | query [*required*]       | string   | The RUM search query used to match events for this node.                                                                                                                                                                    |
| rum_steps    | type [*required*]        | enum     | The type of a step within a RUM operation's journey. Allowed enum values: `start,update,stop,error,abandoned`                                                                                                               |
| attributes   | name [*required*]        | string   | The unique name of the RUM operation. Must not contain spaces.                                                                                                                                                              |
| attributes   | tags [*required*]        | [string] | A list of tags associated with the RUM operation.                                                                                                                                                                           |
| data         | id [*required*]          | string   | The unique identifier of the RUM operation. Must match the ID in the URL path.                                                                                                                                              |
| data         | type [*required*]        | enum     | The JSON:API type for RUM operation resources. Allowed enum values: `operations`                                                                                                                                            |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "abc12345-1234-5678-abcd-ef1234567890",
      "category": "string",
      "description": "string",
      "display_name": "Checkout completed",
      "feature_ids": [],
      "journey_rum": {
        "rum_steps": [
          {
            "composite": {
              "kind": "all_of",
              "max_window_ms": 30000,
              "predicates": [
                {
                  "query": "@type:action @action.type:click"
                }
              ]
            },
            "nodes": [
              {
                "query": "@type:action @action.type:click"
              }
            ],
            "type": "start"
          }
        ]
      },
      "name": "checkout_completed",
      "tags": [
        "team:checkout"
      ]
    },
    "id": "abc12345-1234-5678-abcd-ef1234567890",
    "type": "operations"
  }
}
```

{% /tab %}

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The response for a single RUM operation.

| Parent field | Field                         | Type      | Description                                                                                                                                                                                                                 |
| ------------ | ----------------------------- | --------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
|              | data [*required*]        | object    | The data object in a RUM operation response.                                                                                                                                                                                |
| data         | attributes [*required*]  | object    | Attributes of a RUM operation response.                                                                                                                                                                                     |
| attributes   | application_id                | uuid      | The RUM application ID the operation belongs to.                                                                                                                                                                            |
| attributes   | category                      | string    | The category of the RUM operation.                                                                                                                                                                                          |
| attributes   | created_at                    | date-time | The timestamp when the RUM operation was created.                                                                                                                                                                           |
| attributes   | created_by                    | object    | A Datadog user referenced by a RUM operation.                                                                                                                                                                               |
| created_by   | email                         | string    | The email of the user.                                                                                                                                                                                                      |
| created_by   | handle                        | string    | The handle of the user.                                                                                                                                                                                                     |
| created_by   | name                          | string    | The name of the user.                                                                                                                                                                                                       |
| created_by   | uuid                          | string    | The UUID of the user.                                                                                                                                                                                                       |
| attributes   | description                   | string    | A description of the RUM operation.                                                                                                                                                                                         |
| attributes   | display_name                  | string    | A human-readable display name for the RUM operation.                                                                                                                                                                        |
| attributes   | feature_ids                   | [string]  | The list of feature IDs associated with the RUM operation.                                                                                                                                                                  |
| attributes   | journey_rum [*required*] | object    | The definition of a RUM operation's journey, used to detect it from RUM events.                                                                                                                                             |
| journey_rum  | rum_steps [*required*]   | [object]  | The ordered list of steps composing the RUM journey.                                                                                                                                                                        |
| rum_steps    | composite                     | object    | A composite rule combining several predicates. Used as an alternative to `nodes` on a journey step when several conditions must be matched together, in any order or in a specific order.                                   |
| composite    | composite_rule_id             | string    | The unique identifier of the composite rule. Generated by the server if omitted.                                                                                                                                            |
| composite    | config_version                | string    | A hash of the composite rule's configuration, computed by the server.                                                                                                                                                       |
| composite    | kind [*required*]        | enum      | The rule used to combine the composite rule's predicates. `all_of` requires every predicate to match, in any order. `in_order` requires every predicate to match in the given order. Allowed enum values: `all_of,in_order` |
| composite    | max_window_ms                 | int64     | The maximum time window, in milliseconds, in which all predicates must match.                                                                                                                                               |
| composite    | predicates [*required*]  | [object]  | The list of predicates that must be matched by RUM events.                                                                                                                                                                  |
| predicates   | query [*required*]       | string    | The RUM search query used to match events for this predicate.                                                                                                                                                               |
| rum_steps    | nodes                         | [object]  | The list of nodes that can match this step. Mutually exclusive with `composite`.                                                                                                                                            |
| nodes        | id                            | string    | The unique identifier of the node. Generated by the server if omitted.                                                                                                                                                      |
| nodes        | query [*required*]       | string    | The RUM search query used to match events for this node.                                                                                                                                                                    |
| rum_steps    | type [*required*]        | enum      | The type of a step within a RUM operation's journey. Allowed enum values: `start,update,stop,error,abandoned`                                                                                                               |
| attributes   | name [*required*]        | string    | The unique name of the RUM operation. Must not contain spaces.                                                                                                                                                              |
| attributes   | org_id                        | int64     | The ID of the organization the RUM operation belongs to.                                                                                                                                                                    |
| attributes   | tags [*required*]        | [string]  | A list of tags associated with the RUM operation.                                                                                                                                                                           |
| attributes   | updated_at                    | date-time | The timestamp when the RUM operation was last updated.                                                                                                                                                                      |
| attributes   | updated_by                    | object    | A Datadog user referenced by a RUM operation.                                                                                                                                                                               |
| updated_by   | email                         | string    | The email of the user.                                                                                                                                                                                                      |
| updated_by   | handle                        | string    | The handle of the user.                                                                                                                                                                                                     |
| updated_by   | name                          | string    | The name of the user.                                                                                                                                                                                                       |
| updated_by   | uuid                          | string    | The UUID of the user.                                                                                                                                                                                                       |
| data         | id [*required*]          | string    | The unique identifier of the RUM operation.                                                                                                                                                                                 |
| data         | type [*required*]        | enum      | The JSON:API type for RUM operation resources. Allowed enum values: `operations`                                                                                                                                            |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "application_id": "string",
      "category": "string",
      "created_at": "2019-09-19T10:00:00.000Z",
      "created_by": {
        "email": "string",
        "handle": "string",
        "name": "string",
        "uuid": "string"
      },
      "description": "string",
      "display_name": "Checkout completed",
      "feature_ids": [],
      "journey_rum": {
        "rum_steps": [
          {
            "composite": {
              "composite_rule_id": "string",
              "config_version": "string",
              "kind": "all_of",
              "max_window_ms": 30000,
              "predicates": [
                {
                  "query": "@type:action @action.type:click"
                }
              ]
            },
            "nodes": [
              {
                "id": "string",
                "query": "@type:action @action.type:click"
              }
            ],
            "type": "start"
          }
        ]
      },
      "name": "checkout_completed",
      "org_id": "integer",
      "tags": [
        "team:checkout"
      ],
      "updated_at": "2019-09-19T10:00:00.000Z",
      "updated_by": {
        "email": "string",
        "handle": "string",
        "name": "string",
        "uuid": "string"
      }
    },
    "id": "abc12345-1234-5678-abcd-ef1234567890",
    "type": "operations"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="409" %}
Conflict. An operation with this name already exists.
{% tab title="Model" %}
API error response.

| Parent field | Field                    | Type     | Description                                                                     |
| ------------ | ------------------------ | -------- | ------------------------------------------------------------------------------- |
|              | errors [*required*] | [object] | A list of errors.                                                               |
| errors       | detail                   | string   | A human-readable explanation specific to this occurrence of the error.          |
| errors       | meta                     | object   | Non-standard meta-information about the error                                   |
| errors       | source                   | object   | References to the source of the error.                                          |
| source       | header                   | string   | A string indicating the name of a single request header which caused the error. |
| source       | parameter                | string   | A string indicating which URI query parameter caused the error.                 |
| source       | pointer                  | string   | A JSON pointer to the value in the request document that caused the error.      |
| errors       | status                   | string   | Status code of the response.                                                    |
| errors       | title                    | string   | Short human-readable summary of the error.                                      |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export rum_operation_id="CHANGE_ME" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/rum/operations/${rum_operation_id}" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "journey_rum": {
        "rum_steps": [
          {
            "composite": {
              "kind": "all_of",
              "predicates": [
                {
                  "query": "@type:action @action.type:click"
                }
              ]
            },
            "nodes": [
              {
                "query": "@type:action @action.type:click"
              }
            ],
            "type": "start"
          }
        ]
      },
      "name": "checkout_completed",
      "tags": [
        "team:checkout"
      ]
    },
    "id": "abc12345-1234-5678-abcd-ef1234567890",
    "type": "operations"
  }
}
EOF 
                
##### 

```python
"""
Update a RUM operation returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.rum_operations_api import RUMOperationsApi
from datadog_api_client.v2.model.rum_operation_journey_composite_rule import RUMOperationJourneyCompositeRule
from datadog_api_client.v2.model.rum_operation_journey_composite_rule_kind import RUMOperationJourneyCompositeRuleKind
from datadog_api_client.v2.model.rum_operation_journey_node import RUMOperationJourneyNode
from datadog_api_client.v2.model.rum_operation_journey_predicate import RUMOperationJourneyPredicate
from datadog_api_client.v2.model.rum_operation_journey_rum import RUMOperationJourneyRum
from datadog_api_client.v2.model.rum_operation_journey_step import RUMOperationJourneyStep
from datadog_api_client.v2.model.rum_operation_journey_step_type import RUMOperationJourneyStepType
from datadog_api_client.v2.model.rum_operation_request_attributes import RUMOperationRequestAttributes
from datadog_api_client.v2.model.rum_operation_type import RUMOperationType
from datadog_api_client.v2.model.rum_operation_update_request import RUMOperationUpdateRequest
from datadog_api_client.v2.model.rum_operation_update_request_data import RUMOperationUpdateRequestData
from uuid import UUID

body = RUMOperationUpdateRequest(
    data=RUMOperationUpdateRequestData(
        attributes=RUMOperationRequestAttributes(
            application_id=UUID("abc12345-1234-5678-abcd-ef1234567890"),
            category=None,
            description=None,
            display_name="Checkout completed",
            feature_ids=[],
            journey_rum=RUMOperationJourneyRum(
                rum_steps=[
                    RUMOperationJourneyStep(
                        composite=RUMOperationJourneyCompositeRule(
                            kind=RUMOperationJourneyCompositeRuleKind.ALL_OF,
                            max_window_ms=30000,
                            predicates=[
                                RUMOperationJourneyPredicate(
                                    query="@type:action @action.type:click",
                                ),
                            ],
                        ),
                        nodes=[
                            RUMOperationJourneyNode(
                                query="@type:action @action.type:click",
                            ),
                        ],
                        type=RUMOperationJourneyStepType.START,
                    ),
                ],
            ),
            name="checkout_completed",
            tags=[
                "team:checkout",
            ],
        ),
        id="abc12345-1234-5678-abcd-ef1234567890",
        type=RUMOperationType.OPERATIONS,
    ),
)

configuration = Configuration()
configuration.unstable_operations["update_rum_operation"] = True
with ApiClient(configuration) as api_client:
    api_instance = RUMOperationsApi(api_client)
    response = api_instance.update_rum_operation(rum_operation_id="rum_operation_id", body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
##### 

```ruby
# Update a RUM operation returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.update_rum_operation".to_sym] = true
end
api_instance = DatadogAPIClient::V2::RUMOperationsAPI.new

body = DatadogAPIClient::V2::RUMOperationUpdateRequest.new({
  data: DatadogAPIClient::V2::RUMOperationUpdateRequestData.new({
    attributes: DatadogAPIClient::V2::RUMOperationRequestAttributes.new({
      application_id: "abc12345-1234-5678-abcd-ef1234567890",
      category: nil,
      description: nil,
      display_name: "Checkout completed",
      feature_ids: [],
      journey_rum: DatadogAPIClient::V2::RUMOperationJourneyRum.new({
        rum_steps: [
          DatadogAPIClient::V2::RUMOperationJourneyStep.new({
            composite: DatadogAPIClient::V2::RUMOperationJourneyCompositeRule.new({
              kind: DatadogAPIClient::V2::RUMOperationJourneyCompositeRuleKind::ALL_OF,
              max_window_ms: 30000,
              predicates: [
                DatadogAPIClient::V2::RUMOperationJourneyPredicate.new({
                  query: "@type:action @action.type:click",
                }),
              ],
            }),
            nodes: [
              DatadogAPIClient::V2::RUMOperationJourneyNode.new({
                query: "@type:action @action.type:click",
              }),
            ],
            type: DatadogAPIClient::V2::RUMOperationJourneyStepType::START,
          }),
        ],
      }),
      name: "checkout_completed",
      tags: [
        "team:checkout",
      ],
    }),
    id: "abc12345-1234-5678-abcd-ef1234567890",
    type: DatadogAPIClient::V2::RUMOperationType::OPERATIONS,
  }),
})
p api_instance.update_rum_operation("rum_operation_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
##### 

```go
// Update a RUM operation returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	body := datadogV2.RUMOperationUpdateRequest{
		Data: datadogV2.RUMOperationUpdateRequestData{
			Attributes: datadogV2.RUMOperationRequestAttributes{
				ApplicationId: datadog.PtrUUID(uuid.MustParse("abc12345-1234-5678-abcd-ef1234567890")),
				Category:      *datadog.NewNullableString(nil),
				Description:   *datadog.NewNullableString(nil),
				DisplayName:   datadog.PtrString("Checkout completed"),
				FeatureIds:    []string{},
				JourneyRum: datadogV2.RUMOperationJourneyRum{
					RumSteps: []datadogV2.RUMOperationJourneyStep{
						{
							Composite: &datadogV2.RUMOperationJourneyCompositeRule{
								Kind:        datadogV2.RUMOPERATIONJOURNEYCOMPOSITERULEKIND_ALL_OF,
								MaxWindowMs: datadog.PtrInt64(30000),
								Predicates: []datadogV2.RUMOperationJourneyPredicate{
									{
										Query: "@type:action @action.type:click",
									},
								},
							},
							Nodes: []datadogV2.RUMOperationJourneyNode{
								{
									Query: "@type:action @action.type:click",
								},
							},
							Type: datadogV2.RUMOPERATIONJOURNEYSTEPTYPE_START,
						},
					},
				},
				Name: "checkout_completed",
				Tags: []string{
					"team:checkout",
				},
			},
			Id:   "abc12345-1234-5678-abcd-ef1234567890",
			Type: datadogV2.RUMOPERATIONTYPE_OPERATIONS,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateRUMOperation", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewRUMOperationsApi(apiClient)
	resp, r, err := api.UpdateRUMOperation(ctx, "rum_operation_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `RUMOperationsApi.UpdateRUMOperation`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `RUMOperationsApi.UpdateRUMOperation`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
##### 

```java
// Update a RUM operation returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.RumOperationsApi;
import com.datadog.api.client.v2.model.RUMOperationJourneyCompositeRule;
import com.datadog.api.client.v2.model.RUMOperationJourneyCompositeRuleKind;
import com.datadog.api.client.v2.model.RUMOperationJourneyNode;
import com.datadog.api.client.v2.model.RUMOperationJourneyPredicate;
import com.datadog.api.client.v2.model.RUMOperationJourneyRum;
import com.datadog.api.client.v2.model.RUMOperationJourneyStep;
import com.datadog.api.client.v2.model.RUMOperationJourneyStepType;
import com.datadog.api.client.v2.model.RUMOperationRequestAttributes;
import com.datadog.api.client.v2.model.RUMOperationResponse;
import com.datadog.api.client.v2.model.RUMOperationType;
import com.datadog.api.client.v2.model.RUMOperationUpdateRequest;
import com.datadog.api.client.v2.model.RUMOperationUpdateRequestData;
import java.util.Collections;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.updateRUMOperation", true);
    RumOperationsApi apiInstance = new RumOperationsApi(defaultClient);

    RUMOperationUpdateRequest body =
        new RUMOperationUpdateRequest()
            .data(
                new RUMOperationUpdateRequestData()
                    .attributes(
                        new RUMOperationRequestAttributes()
                            .applicationId(UUID.fromString("abc12345-1234-5678-abcd-ef1234567890"))
                            .category(null)
                            .description(null)
                            .displayName("Checkout completed")
                            .journeyRum(
                                new RUMOperationJourneyRum()
                                    .rumSteps(
                                        Collections.singletonList(
                                            new RUMOperationJourneyStep()
                                                .composite(
                                                    new RUMOperationJourneyCompositeRule()
                                                        .kind(
                                                            RUMOperationJourneyCompositeRuleKind
                                                                .ALL_OF)
                                                        .maxWindowMs(30000L)
                                                        .predicates(
                                                            Collections.singletonList(
                                                                new RUMOperationJourneyPredicate()
                                                                    .query(
                                                                        "@type:action"
                                                                            + " @action.type:click"))))
                                                .nodes(
                                                    Collections.singletonList(
                                                        new RUMOperationJourneyNode()
                                                            .query(
                                                                "@type:action @action.type:click")))
                                                .type(RUMOperationJourneyStepType.START))))
                            .name("checkout_completed")
                            .tags(Collections.singletonList("team:checkout")))
                    .id("abc12345-1234-5678-abcd-ef1234567890")
                    .type(RUMOperationType.OPERATIONS));

    try {
      RUMOperationResponse result = apiInstance.updateRUMOperation("rum_operation_id", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling RumOperationsApi#updateRUMOperation");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
##### 

```rust
// Update a RUM operation returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_rum_operations::RUMOperationsAPI;
use datadog_api_client::datadogV2::model::RUMOperationJourneyCompositeRule;
use datadog_api_client::datadogV2::model::RUMOperationJourneyCompositeRuleKind;
use datadog_api_client::datadogV2::model::RUMOperationJourneyNode;
use datadog_api_client::datadogV2::model::RUMOperationJourneyPredicate;
use datadog_api_client::datadogV2::model::RUMOperationJourneyRum;
use datadog_api_client::datadogV2::model::RUMOperationJourneyStep;
use datadog_api_client::datadogV2::model::RUMOperationJourneyStepType;
use datadog_api_client::datadogV2::model::RUMOperationRequestAttributes;
use datadog_api_client::datadogV2::model::RUMOperationType;
use datadog_api_client::datadogV2::model::RUMOperationUpdateRequest;
use datadog_api_client::datadogV2::model::RUMOperationUpdateRequestData;
use uuid::Uuid;

#[tokio::main]
async fn main() {
    let body = RUMOperationUpdateRequest::new(RUMOperationUpdateRequestData::new(
        RUMOperationRequestAttributes::new(
            RUMOperationJourneyRum::new(vec![RUMOperationJourneyStep::new(
                RUMOperationJourneyStepType::START,
            )
            .composite(
                RUMOperationJourneyCompositeRule::new(
                    RUMOperationJourneyCompositeRuleKind::ALL_OF,
                    vec![RUMOperationJourneyPredicate::new(
                        "@type:action @action.type:click".to_string(),
                    )],
                )
                .max_window_ms(30000),
            )
            .nodes(vec![RUMOperationJourneyNode::new(
                "@type:action @action.type:click".to_string(),
            )])]),
            "checkout_completed".to_string(),
            vec!["team:checkout".to_string()],
        )
        .application_id(
            Uuid::parse_str("abc12345-1234-5678-abcd-ef1234567890").expect("invalid UUID"),
        )
        .category(None)
        .description(None)
        .display_name("Checkout completed".to_string())
        .feature_ids(vec![]),
        "abc12345-1234-5678-abcd-ef1234567890".to_string(),
        RUMOperationType::OPERATIONS,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.UpdateRUMOperation", true);
    let api = RUMOperationsAPI::with_config(configuration);
    let resp = api
        .update_rum_operation("rum_operation_id".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
##### 

```typescript
/**
 * Update a RUM operation returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.updateRUMOperation"] = true;
const apiInstance = new v2.RUMOperationsApi(configuration);

const params: v2.RUMOperationsApiUpdateRUMOperationRequest = {
  body: {
    data: {
      attributes: {
        applicationId: "abc12345-1234-5678-abcd-ef1234567890",
        category: undefined,
        description: undefined,
        displayName: "Checkout completed",
        featureIds: [],
        journeyRum: {
          rumSteps: [
            {
              composite: {
                kind: "all_of",
                maxWindowMs: 30000,
                predicates: [
                  {
                    query: "@type:action @action.type:click",
                  },
                ],
              },
              nodes: [
                {
                  query: "@type:action @action.type:click",
                },
              ],
              type: "start",
            },
          ],
        },
        name: "checkout_completed",
        tags: ["team:checkout"],
      },
      id: "abc12345-1234-5678-abcd-ef1234567890",
      type: "operations",
    },
  },
  rumOperationId: "rum_operation_id",
};

apiInstance
  .updateRUMOperation(params)
  .then((data: v2.RUMOperationResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"
{% /tab %}
